// TODO
// Figure out what pins go to which links and magnets

#include <18f4520.h>
#include <swinging.h>

#priority rda

//Theta tprev = {0,0};

#define CW MOTORN
#define CCW MOTORP

#define INPHASE MOTORP
#define OUTPHASE MOTORN

int8 phase = OUTPHASE;

#int_rda
void rx()
{
   int16 i;
   
   i = getch();
   
   if(i == 0x20) { // spacebar
      disable_interrupts(INT_CCP1);
      disable_interrupts(INT_CCP2);
      actuators.output = 0;
      actuators.magnets = BOTH_MAGNETS_ON;
      actuators.hen = OFF;
      actuate();
      printf("emergency mode activated!\r\n");
   }
   else if(i == 's') {
      actuators.hen = OFF;
      actuators.hdir = OFF;
      actuate();
      printf("STOP!!!\r\n");
   }
   else if(i == 'g') {
      printf("GO!!!\r\n");
      actuators.output = 0;
      actuators.magnets = ONLY_MAGNET1_ON;
      actuators.hen = ON;
      actuate();

      enable_interrupts(INT_CCP1);
      enable_interrupts(INT_CCP2);
   }
   else if(i == 'w') {
      printf("SWITCH!!!\r\n");
      if(actuators.magnets == ONLY_MAGNET2_ON) {
         actuators.magnets = ONLY_MAGNET1_ON;
      }
      else {
         actuators.magnets = ONLY_MAGNET2_ON;
      }
      actuators.hen = ON;
      actuate();
   }
   else if(i == 'c') {
      actuators.output = 0;
      actuators.magnets = BOTH_MAGNETS_ON;
      actuators.hen = OFF;
      actuate();
      printf("CATCH!\r\n");
   }
   else if(i == 'p') {
      printf("PHASE!!!\r\n");
      phase = 3 - phase;
   }
   else if(i == 'j') {
      actuators.hen = ON;
      actuators.hdir = MOTORN;
      actuate();
   }
   else if(i == 'k') {
      actuators.hen = ON;
      actuators.hdir = MOTORP;
      actuate();
   }   
   
   
}

int ov = 0;
#int_timer3
void overflow()
{
   ov++;
}
void no_change()
{  
   //printf("%u no change\r\n", i);
   //i++;

   if(actuators.hdir == MOTORN) {
      actuators.hdir = MOTORP;
   }
   else {
      actuators.hdir = MOTORN;
   }
   
   actuate();
   set_timer3(SAMPLE_PERIOD);
}

#int_ccp1
void up_count()
{
   set_timer3(SAMPLE_PERIOD);
   if(phase == INPHASE) {
      actuators.hdir = MOTORP;
   }
   else {
      actuators.hdir = MOTORN;
   }
   
   actuate();
   //sensors.tccp.position++;
}

#int_ccp2
void down_count()
{
   set_timer3(SAMPLE_PERIOD);
   if(phase == INPHASE) {
      actuators.hdir = MOTORN;
   }
   else {
      actuators.hdir = MOTORP;
   }
   
   actuate();
   //sensors.tccp.position--;
}

#define DELAY_ON2_CCW1 625
#define DELAY_ON2_CW1 590

#define DELAY_ON1_CCW2 625
#define DELAY_ON1_CW2 590

void on1ccw2()
{
   actuators.hen = ON;
   actuators.magnets = ONLY_MAGNET1_ON;
   actuators.hdir = MOTORP;
   actuate();

   delay_ms(DELAY_ON1_CCW2);

   actuators.hen = OFF;
   actuators.magnets = BOTH_MAGNETS_ON;
   actuate();
}

void on1cw2()
{
   actuators.hen = ON;
   actuators.magnets = ONLY_MAGNET1_ON;
   actuators.hdir = MOTORN;
   actuate();

   delay_ms(DELAY_ON1_CW2);

   actuators.hen = OFF;
   actuators.magnets = BOTH_MAGNETS_ON;
   actuate();
}

void on2ccw1()
{
   actuators.hen = ON;
   actuators.magnets = ONLY_MAGNET2_ON;
   actuators.hdir = MOTORN;
   actuate();

   delay_ms(DELAY_ON2_CCW1);

   actuators.hen = OFF;
   actuators.magnets = BOTH_MAGNETS_ON;
   actuate();
}

void on2cw1()
{
   actuators.hen = ON;
   actuators.magnets = ONLY_MAGNET2_ON;
   actuators.hdir = MOTORP;
   actuate();

   delay_ms(DELAY_ON2_CW1);

   actuators.hen = OFF;
   actuators.magnets = BOTH_MAGNETS_ON;
   actuate();
}

// @ 8.5 V
#define A() on1ccw2()
#define S() on1cw2()
#define D() on2ccw1()
#define F() on2cw1()
#define DELAY 30

void demo(int8 i)
{
   while(i > 0) {
      D();
      delay_ms(DELAY);
      A();
      delay_ms(DELAY);
      S();
      delay_ms(DELAY);
      F();
      delay_ms(DELAY);
      i--;
   }
}

void down()
{
   actuators.hen = OFF;
   actuators.magnets = ONLY_MAGNET2_ON;
   actuate();
   
   delay_ms(10);
   
   actuators.magnets = ONLY_MAGNET1_ON;
   actuate();
   
   delay_ms(10);
   
   actuators.magnets = BOTH_MAGNETS_ON;
   actuate();
}

void main()
{
   int16 i = 0;
   //int16 dur, step, i;
   // initialize everything
   set_tris_b(0);
   //set_tris_c(0x80);
   set_tris_d(0);

   //setup_ccp1(CCP_CAPTURE_DIV_16);
   //setup_ccp2(CCP_CAPTURE_DIV_16);
   //setup_timer_1(T1_INTERNAL);
   //setup_timer_3(T3_INTERNAL | T3_DIV_BY_8);
   
   sensors.renc_mux = SEL_ROTARY_ENCODER_1;
   mux_out();

   set_quad_dec(QUAD_DEC_X1);
   actuators.output = 0;
   actuators.magnets = BOTH_MAGNETS_ON;
   actuators.hen = OFF;
   actuate();
   
  // enable_interrupts(INT_CCP1);
   //enable_interrupts(INT_CCP2);
  // enable_interrupts(INT_RDA);
   //enable_interrupts(INT_TIMER3);
  // enable_interrupts(GLOBAL);
  

   printf("Hello World!\r\n");
   
   while(TRUE) {
      i = getch();
      if(i == 'j') {
         actuators.hen = ON;
         actuators.hdir = MOTORN;
         actuate();
      }
      else if(i == 'k') {
         actuators.hen = ON;
         actuators.hdir = MOTORP;
         actuate();
      }
      else if(i == '1') {
         actuators.hen = OFF;
         actuators.magnets = ONLY_MAGNET1_ON;
         actuate();
         printf("MAG1 ON!!!\r\n");
      }
      else if(i == '2') {
         actuators.hen = OFF;
         actuators.magnets = ONLY_MAGNET2_ON;
         actuate();
         printf("MAG2 ON!!!\r\n");
      }
      else if(i == 'b') {
         actuators.hen = OFF;
         actuators.magnets = BOTH_MAGNETS_ON;
         actuate();
         printf("BOTH MAGS ON!!!\r\n");
      }     
      else if(i =='a') {
         on1ccw2();     
      }
      else if(i =='s') {
         on1cw2();     
      }
      else if(i =='d') {
         on2ccw1();     
      }
      else if(i =='f') {
         on2cw1();     
      }
      else if(i == 'o') {
         demo(7);
      }
      else if(i == 'y') {
         down();
      }      
      else {
         actuators.hen = OFF;
         actuate();
      }
   }
}
