#fuses HS,NOLVP,NOWDT,NOPROTECT
#use delay(clock=40000000)
#use rs232(baud=9600, UART1)

#define HBRIDGE_EN PIN_D2
#define MOTORP 2
#define MOTORN 1
#define ACCELEROMETER
#define ENCODER
#define MAGNET1 PIN_D7
#define MAGNET2 PIN_D6

#define ON 1
#define OFF 0

#define ONLY_MAGNET1_ON 1
#define ONLY_MAGNET2_ON 2
#define BOTH_MAGNETS_ON 3

#define SEL_ROTARY_ENCODER_1 1
#define SEL_ROTARY_ENCODER_2 2

#define QUAD_DEC_X1 0
#define QUAD_DEC_X4 1

#define SAMPLE_PERIOD 0//10922
#define SAMPLE_DELAY 4

#define flip(a) (actuators.##a = 3 - actuators.##a)
#define actuate() output_d(actuators.output)
#define mux_out() (output_b(sensors.renc_mux))
#define mux_flip() (sensors.renc_mux = 3 - sensors.renc_mux)
#define set_quad_dec(m) (output_bit(PIN_C4, (m)))


struct theta_t {
   signed int16 position;
   signed int16 velocity;
};

typedef struct theta_t Theta;


union {
// This code is NOT (ANSI) portable.  It makes a strong assumption about the
// memory layout of actuators.
   int8 output;
   struct state {
      int hdir : 2; // h-bridge direction
      int hen : 1; // h-bridge enable
      int unused : 3;
      int magnets : 2; // magnet 2 (msb), magnet 1 (lsb)
   };
} actuators;

struct {
   Theta tqei; // angular position and velocity inputs from QEI module
   Theta tccp; // angular position and velocity inputs from the CCP module
   int renc_mux : 2; // rotary encoder multiplixer state
} sensors;
